#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Hor_Value_Slider.H>
#include <FL/fl_draw.H>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <string.h>


static int line_data[700];
static int line_position=0;
static int tty=0;

class Drawing : public Fl_Widget {
  void draw() {
  static int init=0;
  int i, first=1;
  static int ox=0, oy=0, nx, ny;

  fl_color(FL_BLACK);
  if (!init) {
   init=1;
   fl_rectf(0,0,600, 256);
  }


  if ( line_position-90 < 0 )
	fl_rectf(0,0,150, 300);
  else
  	fl_rectf(line_position-50, 0, line_position, 256);
  fl_color(FL_YELLOW);
  for ( i=line_position; i--; i>(line_position-25) ) {
	nx=line_position-i; ny=256-line_data[line_position-i];
	if (ox > 3 && oy >3 && ny > 3 && nx > 3 &&
	    nx < 600 && ox < 600 && oy < 300 && ny < 300 )
		fl_line(ox, oy, nx, ny);
	ox=nx; oy=ny;
  }
}

public:
  Drawing(int X,int Y,int W,int H) : Fl_Widget(X,Y,W,H) {}
};
static Drawing *d;


void poll_serial(void*) {
    unsigned char string[5];

	while (read(tty, string, 1) > 0) {
		line_data[line_position++]=*string;
		if (line_position > 599) 
			line_position=0;
	}

	Fl::repeat_timeout(.01,poll_serial);
}

void redraw_window(void*) {
	d->redraw();
	Fl::repeat_timeout(.1,redraw_window);
}

int main(int argc, char** argv) {
  Fl_Double_Window window(600,256);
  Drawing drawing(0,0,600,256);

  d = &drawing;

  tty=open("/dev/cuaa0",O_RDONLY);
  if ( tty < 1 ) {
      printf("Could not open serial port\n");
      return -1;
  }

  if ( fcntl(tty, F_SETFL, O_NONBLOCK) == -1 )
	printf("Fcntl failed\n");

  bzero(line_data, 320);



  Fl::add_timeout(.01,poll_serial);
  Fl::add_timeout(1.0,redraw_window);

  window.end();
  window.show(argc,argv);
  return Fl::run();
}


