/*
A Craptastic Program by Bear! 2/03/03	
*/

#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <stdio.h>
#include <stdlib.h>
#include "term.h"
#include "uart.h"

void delay(char d) {
   unsigned char i, j, k;

	while (1) {
		if ( i++ == 0xff) 
			if (j++ == 0xff) 
				if (k++ > d) 
					return;
	}

}

#define ADC_SAMPLE_SIZE 20
static unsigned char adc_sample_ready_bit=0;
static unsigned char adc_buf[ADC_SAMPLE_SIZE];
static unsigned char adc_count=0;

SIGNAL(SIG_ADC) {
	adc_buf[adc_count++]=ADCH;
	if (adc_count >= ADC_SAMPLE_SIZE) {
		adc_sample_ready_bit=1;
		adc_count=0;
	}
}

char adc_sample_ready() {
	if (adc_sample_ready_bit) {
		adc_sample_ready_bit=0;
		return 1;
	} else
		return 0;
}

void adc_init() {
	ADMUX=0xe0;
	ADCSRA=0xed;
	set_sleep_mode(SLEEP_MODE_IDLE);
}

/* Computes a average of the values in adc_buf */
unsigned char adc_sample () {
	static char foo=0;
	char i; unsigned int average;
	unsigned char highest=0, high=0, low=0, lowest=0;

	/* Remove the two highest, and lowest values */
	/*

	for (i=0; i<ADC_SAMPLE_SIZE;  i++) {

		if ( adc_buf[i] > adc_buf[high] ) 
			if ( adc_buf[i] > adc_buf[highest] ) {
				high=highest;
				highest=i;
			} else
				high=i;	
		if ( adc_buf[i] < adc_buf[low] )
			if ( adc_buf[i] < adc_buf[lowest] ) {
				low=lowest;
				lowest=i;
			} else
				low=i;
	} 

	/* Average the data */

	for (i=0; i<ADC_SAMPLE_SIZE;  i++) {
		average+=adc_buf[i];
	}
	average=average/(ADC_SAMPLE_SIZE);

	/*automatic_gain_control (average);*/

	return ((char) average );
}

void automatic_gain_control_set(char value) {
 /*
  * We use MISO/MOSI/SCK, which are PB3-PB5
  */
	static char init=0;
	
	static unsigned char current_pos=0;

	if (!init)
		DDRB=0x1c;

	if (value)
		if ( current_pos > 6 ) /* an error condition, AGC, can't go higher */
			DDRB=0x10;
		else {
			DDRB=0x00;
			current_pos++;
		}
	else
		if (current_pos < 1 )
			DDRB=0x08;
		else {
			current_pos--;
			DDRB=0x00;
		}

}

void automatic_gain_control ( int average ) {
	static int max = 0x70;
	if ( average > max ) 
		max=average;

	if (max > 0xf7) { /* never allow values that are too big */
		automatic_gain_control_set(0);
		max=0x70;
	}

	if (max < 0x0f) { /* min value we should decay to */
		automatic_gain_control_set(1);
		max=0x70;
	}
		
	max--; /* decay rate */
}

int main( void )
{

unsigned char count=0;

	DDRD=0x18;
	PORTD=0x18;

	init_serial();

	adc_init();
	delay(0x2f);

   	fdevopen( (void*)(uart_putchar),(void*)(uart_getchar), 0);
/*
	printf("\n\rSampling Data\n\r");
*/

	PORTD=0x00;

	sei();

   	while (1) {
   		if (adc_sample_ready()) {
			/*printf("%3d ", adc_sample()) ;*/
			putchar(adc_sample());
		}
   		sleep_mode();
   	}



   
}
