/* A modified version of atmels usart routines 
 * modified by charles shiflett 
 */

#include <avr/io.h>


#define USART_TX_BUFFER_SIZE 16
static unsigned char TxBuf[USART_TX_BUFFER_SIZE];
static volatile unsigned char TxHead;
static volatile unsigned char TxTail;

void init_serial () {
   UCSRA=(UCSRA|0x02) & 0xfe;
   UCSRB=(1<<RXEN) | (1<<TXEN) ;
   UCSRC=0x86;
   UBRRL=0x0c;
   UCSRC=0x00;

   TxHead=TxTail=0;
}

SIGNAL (SIG_UART_DATA) {
	unsigned char tmp;

	if (TxHead == TxTail) {
		/* Transmission Copmlete (Yah!) */
		UCSRB &= ~(1<<UDRIE);
		return;
	}

	tmp=TxTail=TxTail+1&(USART_TX_BUFFER_SIZE-1);
	UDR=TxBuf[tmp];

}

void uart_putchar(char c) {
	unsigned char tmp;

	while (!(UCSRA & (1<<UDRE)));
	UDR=c;
	return ;

	/*
	if (UCSRA & (1<<UDRE)) {
		UDR=c;
		return;
	} */

	tmp = TxHead + 1 & (USART_TX_BUFFER_SIZE-1);

	while (tmp == TxTail)  {
		tmp = TxHead + 1 & (USART_TX_BUFFER_SIZE-1);
	}

	TxBuf[tmp]=c;
	TxHead=tmp;
	UCSRB|=1<<UDRIE;


}

char uart_getchar(char c){
	return 0;
}

